
----------------------------------------------------------------------------------------------------------------------
--
--	TOOLTIP V1.1 BY GALUHAD
--
--	Usage: Tooltip.Create(Sender,Message) 	where Sender equals control generating the tooltip, and message equals message to display
--  										Use of "\n" in Message will register a new line in the tooltip.
--
-----------------------------------------------------------------------------------------------------------------------

Tooltip = {};

function Tooltip.Create(SENDER,MESSAGE)

	if MESSAGE == nil then return end;
	if SENDER == nil then return end;

	-- This creates the tooltip


	local TIMESTAMP = 0;

	SENDER:SetMouseVisible(true);

	SENDER.MouseEnter = function (sender,args)

		TIMESTAMP = Turbine.Engine.GetLocalTime();
		SENDER:SetWantsUpdates(true);

	end

	SENDER.MouseLeave = function (sender,args)

		SENDER:SetWantsUpdates(false);
		if ttBorderWin ~= nil then ttBorderWin:Close() end;

	end

	SENDER.Update = function (sender, args)

		if Turbine.Engine.GetLocalTime() > TIMESTAMP+1 then

			SENDER:SetWantsUpdates(false);

			local MAXWIDTH = 400;


			local NewTooltip = {};

			ttBorderWin = Turbine.UI.Window();
			ttBorderWin:SetPosition(Turbine.UI.Display.GetMouseX()+16,Turbine.UI.Display.GetMouseY()+5);
			ttBorderWin:SetSize(10,8);
			ttBorderWin:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5));
			ttBorderWin:SetMouseVisible(false);
			ttBorderWin:SetVisible(true);

			ttBackground = Turbine.UI.Control();
			ttBackground:SetParent(ttBorderWin);
			ttBackground:SetPosition(2,2);
			ttBackground:SetSize(2,4);
			ttBackground:SetBackColor(Turbine.UI.Color.Black);


			-- Messy code to find newline characters.
			local t = {};
			local x = 0;
			t[1] = 1;
			while true do
				x = string.find(MESSAGE,"\n",x+1);
				if x == nil then break end;
				t[x] = x;
			end
			t[string.len(MESSAGE)] = string.len(MESSAGE);
			table.sort(t);

			local _NEWLINES = {};

			for k,v in pairs (t) do
				table.insert(_NEWLINES,v);
			end
			table.sort(_NEWLINES);


			local ttMainLabel ={};

			for i=1, (table.getn(_NEWLINES)-1) do

				local CURMESSAGE = string.sub(MESSAGE,_NEWLINES[i],_NEWLINES[i+1]);

				CURMESSAGE = string.gsub(CURMESSAGE,"\n","");

				ttMainLabel[i] = Turbine.UI.TextBox();
				ttMainLabel[i]:SetParent(ttBackground);
				ttMainLabel[i]:SetSize(1,18);
				ttMainLabel[i]:SetPosition(2,2+(18*(i-1)));
				--ttMainLabel[i]:SetBackColor(Turbine.UI.Color(0,0,0));
				ttMainLabel[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
				ttMainLabel[i]:SetMultiline(false);
				ttMainLabel[i]:SetMarkupEnabled(true);
				ttMainLabel[i]:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
				ttMainLabel[i]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
				ttMainLabel[i]:SetMouseVisible(false);


				ttBorderWin:SetHeight(ttBorderWin:GetHeight()+18);
				ttBackground:SetHeight(ttBackground:GetHeight()+18);

				local hScroll = Turbine.UI.Lotro.ScrollBar();
				hScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
				hScroll:SetSize(1,1);
				hScroll:SetParent(ttMainLabel[i]);
				ttMainLabel[i]:SetHorizontalScrollBar(hScroll);

				ttMainLabel[i]:SetText(CURMESSAGE);

				if hScroll:IsVisible() then

					local iCount = 1;

					while hScroll:IsVisible() and iCount < 100 do
						ttMainLabel[i]:SetWidth(ttMainLabel[i]:GetWidth() + 5);
						iCount = iCount + 1;
					end

				end

				ttMainLabel[i]:SetHorizontalScrollBar(nil);

				ttMainLabel[i]:SetWidth(ttMainLabel[i]:GetWidth()+10);

				if ttBorderWin:GetWidth() < (ttMainLabel[i]:GetWidth()+2) then
					ttBorderWin:SetWidth(ttMainLabel[i]:GetWidth()+2);
					ttBackground:SetWidth(ttBorderWin:GetWidth()-4);
				end

			end


			ttBorderWin.Closed = function ()
				ttBorderWin = nil;
				ttMainLabel = nil;
			end


			-- This part creates the metatable.
			Tooltip.__index = Tooltip;
			Tooltip.__newindex = Tooltip;

			setmetatable(NewTooltip,Tooltip);


		--~ 	function NewTooltip:SetMaxWidth(VALUE)


		--~ 	end

		--~ 	NewTooltip.GetMaxWidth = function ()

		--~ 		return BUTTONPRESSED;

		--~ 	end

			return NewTooltip;


		end

	end


end


